# File Name: CS2303_autograder.py
# Author: Jonathan Morse

# Used to access command line arguments 
import sys
sys.path.insert(0, './')
from autograder_core import *
# Allows shell commands
import subprocess
# Allows access to file system
import os

def UI():
    print("\nCS2303 AUTO GRADER\n")
    TA_first_name = input("What is your first name? ")
    TA_last_name = input("What is your last name? ")
    AG_of_choice = input("What programming assignment is this for? ")

    compile_doc = open("./Output_Files/did_not_compile.txt", "w")
    clean_doc = open("./Output_Files/not_clean.txt", "w")

    # Unzips all student files
    unzip_file = unzip_organize()

    # Name of zip file containing all students code
    zip_file_name = unzip_file[1]

    # Creates a list of all student's names
    list_of_students = unzip_file[0]

    # Number of students being graded 
    num_of_students = len(list_of_students)

    if AG_of_choice is "1":
        # Deletes the not_clean.txt file because it is not needed for PA1
        clean_doc.close()
        subprocess.run("rm ./Output_Files/not_clean.txt", shell=True)

        for x in range(0,num_of_students):
            # Moves student files into autograder folder
            subprocess.run("mv ./Insert_Zip_File_Here/%s/%s ./PA1/" \
                % (zip_file_name,list_of_students[x]),
                           shell=True)
            # Runs autograder for each student project 
            subprocess.run("cd ./PA1/; python3 PA1_autograder.py %s %s %s;" 
                % (TA_first_name,TA_last_name,list_of_students[x]),
                           shell=True)
    elif AG_of_choice is "2":
        for x in range(0,num_of_students):
            subprocess.run("mv ./Insert_Zip_File_Here/%s/%s ./PA2/" 
                % (zip_file_name,list_of_students[x]),
                           shell=True)
            subprocess.run("cd ./PA2/; python3 PA2_autograder.py %s %s %s;" 
                % (TA_first_name,TA_last_name,list_of_students[x]),
                           shell=True)
    elif AG_of_choice is "3":
        for x in range(0,num_of_students):
            subprocess.run("mv ./Insert_Zip_File_Here/%s/%s ./PA3/" 
                % (zip_file_name,list_of_students[x]),
                           shell=True)
            subprocess.run("cd ./PA3/; python3 PA3_autograder.py %s %s %s;"
                % (TA_first_name,TA_last_name,list_of_students[x]),
                           shell=True)
    elif AG_of_choice is "4":
        subprocess.run("cd ./PA4/; python3 PA4_autograder.py %s %s %s;"
            % (TA_first_name,TA_last_name,list_of_students[x]),
                       shell=True)
    elif AG_of_choice is "5":
        subprocess.run("cd ../PA5/; python3 PA5_autograder.py %s %s %s;"
            % (TA_first_name,TA_last_name,list_of_students[x]),
                       shell=True)
    elif AG_of_choice is "6":
        subprocess.run("cd ../PA6/; python3 PA6_autograder.py %s %s %S;"
            % (TA_first_name,TA_last_name,list_of_students[x]),
                       shell=True)
    else:
        print("Invalid character entered, please enter a number " \
              + "1-6 for autograder to work correctly")

    subprocess.run("rm -r ./Insert_Zip_File_Here/%s" % (zip_file_name),
                   shell=True,
                   stdout=subprocess.PIPE,
                   stderr=subprocess.PIPE)

UI()

