# File Name: PA1_autograder.py
# Author: Jonathan Morse

# Used to access command line arguments 
import sys
sys.path.insert(0, '../')
from autograder_core import *
# Allows shell commands
import subprocess
# Allows access to file system
import os

def main(grader_first_name,grader_last_name,student_file_name):

    # Initializing values of earned points by students on tasks for project.
    # -1 is used for tasks the autograder cannot grade. 

    task_one_score_earned = 0
    task_two_score_earned = 0
    task_three_score_earned = 0
    task_four_score_earned = 0 
    task_five_score_earned = 0
    task_six_score_earned = -1
    task_seven_score_earned = -1

    # Initializing values of possible points that a student could earn 

    task_one_score_possible = 2
    task_two_score_possible = 2
    task_three_score_possible = 1
    task_four_score_possible = 3
    task_five_score_possible = 5
    task_six_score_possible = 2
    task_seven_score_possible = 5

    # Initializing reason for score variables for tasks

    task_one_reason_for_score = ""
    task_two_reason_for_score = ""
    task_three_reason_for_score = ""
    task_four_reason_for_score = ""
    task_five_reason_for_score = ""
    task_six_reason_for_score = "Autograder cannot grade this task"
    task_seven_reason_for_score = "Autograder cannot grade this task"

    # Command used to compile student program 
    compile_command = "gcc -Wall -o PA1 PA1.c"

    # Command used to run student program 
    run_command = "./PA1"

    # Moves student PA1.c file into same directory as autograder
    subprocess.run("mv %s/PA1.c ./" % (student_file_name),
                   shell=True,
                   stdout=subprocess.PIPE,
                   stderr=subprocess.PIPE)
    # Delete student folder, only file needed for the autograder
    # in the folder is PA1.c
    subprocess.run("rm -r %s" % (student_file_name),
                   shell=True,
                   stdout=subprocess.PIPE,
                   stderr=subprocess.PIPE)
    # Building test files used for check_year function
    subprocess.run("gcc -Wall -o PA1_Test PA1_Test.c",
                   shell=True,
                   stdout=subprocess.PIPE,
                   stderr=subprocess.PIPE)


    # Task 1. Compile Test

    # Tests to ensure PA1.c compiles

    task_one_test = compile_test(compile_command,
                                 task_one_score_possible)

    task_one_score_earned = task_one_test[0]

    task_one_reason_for_score = task_one_test[1]

    # If PA1.c did not compile then the students name is added to
    # the did_not_compile.txt file located in the Output_Files 
    # directory. 

    compile_check_test = compile_check(task_one_score_earned, 
                                       task_one_score_possible, 
                                       student_file_name)

    # Ends autograder if program did not compile
    if task_one_score_earned != task_one_score_possible:
        return

    # Task 2. Grader Test Cases

    # Test to see if the first week of each month prints correctly for year 1
    Task_Two_Test_One = check_year(run_command,1)

    # Sets reason for score based on result of test one
    if Task_Two_Test_One == 1:
        task_two_reason_for_score = "\n\tCorrectly printed calendar for " \
                                    + "year 1, test case one passed"
    else:
        task_two_reason_for_score = "\n\tDid not correctly print calendar" \
                                    + "for year 1, test case one failed"

    # Test to see if the first week of each month prints 
    # correctly for year 2010
    Task_Two_Test_Two = check_year(run_command,2010)

    # Sets reason for score based on result of test two
    if Task_Two_Test_Two == 1:
        task_two_reason_for_score = task_two_reason_for_score \
                                    + "\n\tCorrectly printed calendar" \
                                    + " for year 2010, test case two passed"
    else:
        task_two_reason_for_score = task_two_reason_for_score \
                                    + "\n\tDid not correctly print calendar" \
                                    + "for year 2010, test case two failed"

    task_two_score_earned = Task_Two_Test_One + Task_Two_Test_Two

    # Task 3. Scanf() Test

    # Checks if the user inputed year is printed on the output
    task_three_test = search_word(run_command,
                                  1000000,
                                  "January",
                                  "1000000",
                                  task_three_score_possible)

    task_three_score_earned = task_three_test[0]
    task_three_reason_for_score = task_three_test[1]
    

    # Task 4. Printf() Test

    # Tests to see if code correctly prints first week of January
    # in year 1000000
    task_four_test = check_month(run_command,
                                 1000000,
                                 'n',
                                 '1',
                                 "January",
                                 task_four_score_possible)

    task_four_score_earned = task_four_test[0]
    task_four_reason_for_score = task_four_test[1]


    # Task Five. Conditional and Loop statement tests

    # Test to see if the first week of each month is printed correctly
    # for year 2000. The year 2000 is used because it requires that the 
    # program checks all three leap year rules before outputing the calendar
    Task_Five_Test = check_year("./PA1",2000)
    
    if Task_Five_Test == 1: 
        task_five_score_earned = 5
        task_five_reason_for_score = "\n\tCalendar for year 2000 printed" \
                                     + " correctly, conditional and loop " \
                                     + "statements are implemented " \
                                     + "correctly"
    else:
        task_five_score_earned = 0 
        task_five_reason_for_score = "\n\tCalendar for year 2000 printed " \
                                     + "incorrectly, conditional and loop" \
                                     + " statements are implemented incorrectly"

    # Delete program ".c" file, compiled program file, and compiled test file
    subprocess.run("rm PA1;rm PA1.c;rm PA1_Test",
                   shell=True,
                   stdout=subprocess.PIPE,
                   stderr=subprocess.PIPE)

    # Rubric 

    # Opens the rubric text file
    r = open("../Output_Files/Rubrics/%s_PA1_rubric.txt" 
        % (student_file_name), "w")

    # Creates header
    r.write(str(header("ONE",
    	               student_file_name,
    	               grader_first_name,
    	               grader_last_name,
    	               "Twenty(20)"
    	               )))
    # Task 1
    r.write(str(task_create("One",
    	                   "Compilation without warnings",
    	                   task_one_score_possible,
    	                   task_one_score_earned,
    	                   task_one_reason_for_score
    	                   )))
    # Task 2
    r.write(str(task_create("Two",
    	                   "Correct execution with graders` test cases",
    	                   task_two_score_possible,
    	                   task_two_score_earned,
    	                   task_two_reason_for_score
    	                   )))
    # Task 3
    r.write(str(task_create("Three",
    	                   "Correct usage of scanf() to get inputs from user",
    	                   task_three_score_possible,
    	                   task_three_score_earned,
    	                   task_three_reason_for_score
    	                   )))
    # Task 4
    r.write(str(task_create("Four",
    	                   "Correct usage of printf() to print the various" \
                           + "lines of the calendar",
    	                   task_four_score_possible,
    	                   task_four_score_earned,
    	                   task_four_reason_for_score
    	                   )))
    # Task 5 
    r.write(str(task_create("Five",
    	                   "Correct usage of conditional and loop statements",
    	                   task_five_score_possible,
    	                   task_five_score_earned,
    	                   task_five_reason_for_score
    	                   )))
    # Task 6
    r.write(str(task_create("Six",
    	                   "Satisfactory README file",
    	                   task_six_score_possible,
    	                   task_six_score_earned,
    	                   task_six_reason_for_score
    	                   )))
    # Task 7 
    r.write(str(task_create("Seven",
    	                   "Loop invariant for each loop in comments in the" \
                           + "code and also in the README documentation",
    	                   task_seven_score_possible,
    	                   task_seven_score_earned,
    	                   task_seven_reason_for_score
    	                   )))
    r.close()
    return;

main(sys.argv[1],sys.argv[2],sys.argv[3])

