#include <stdio.h>


int isLeapYear(int year)
{
	if ( year % 4 == 0)
	{
		if ( year % 100 == 0)
		{
			if ( year % 400 == 0)
			{
				return 1; 
			}
			return 0;
		}
		return 1;
	}
	return 0; 
}

int isFirstDay(int daysInMonth, int prevStartDay)
{
  int allDays = (daysInMonth + prevStartDay); 
  //printf("total number of days %d\n", allDays);
  int firstDay = 0; 
  while (allDays > 7)
  {
    allDays = (allDays - 7); 
    //printf("number of days left %d\n", allDays);
  }
  firstDay = (allDays + firstDay); 
  return firstDay; 
}


int startDayOfYear(int year)
{
  int startDay = 1; 
	int fourLeap = (year / 4);
  //printf("number of 4th years %d\n", fourLeap); 
	int hundLeap = (year / 100); 
  //printf("number of 100th years %d\n", hundLeap);
	int fourHundLeap = (year / 400); 
  //printf("number of 400th years %d\n", fourHundLeap);
	int totLeap = (fourLeap - hundLeap + fourHundLeap);
  //printf("total number of leap years %d\n", totLeap);
  int totNonLeap = (year - totLeap);
  //printf("number of non leap years %d\n", totNonLeap);
  int totalDays = ((totLeap * 366) + (totNonLeap*365));
  //printf("total number of days %d\n", totalDays);
  while (totalDays >= 6)
  {
    totalDays = (totalDays - 7); 
    //printf("total number of days remaining %d\n", totalDays);
  }
  startDay = (startDay + totalDays);
  //printf("start day is %d\n", startDay);
	return startDay; 
}


int printWeek()
{
	printf("Sun  ");
	printf("Mon  ");
	printf("Tue  ");
	printf("Wed  ");
	printf("Thu  ");
	printf("Fri  ");
	printf("Sat\n");

	return 0; 
}


int printMonthName(int month, int year)
{

   switch(month) {
      case 1 :
         printf("January %d\n\n", year );
         break;
      case 2 :
      	 printf("February %d\n\n", year);
         break;
      case 3 :
         printf("March %d\n\n", year);
         break;
      case 4 :
         printf("April %d\n\n", year);
         break;
      case 5 :
         printf("May %d\n\n", year);
         break;
      case 6 :
         printf("June %d\n\n", year);
         break;
      case 7 :
         printf("July %d\n\n", year);
         break;
      case 8 :
         printf("August %d\n\n", year);
         break;
      case 9 :
         printf("September %d\n\n", year);
         break;
      case 10 :
         printf("October %d\n\n", year);
         break;
      case 11 :
         printf("November %d\n\n", year);
         break;
      case 12 :
         printf("December %d\n\n", year);
         break;
   }

   return 0;
}

int printFirstWeek(int startDay)
{
	int day = 1; 
   switch(startDay) {
      case 1 :
	printf("%3d",day);
	day++; 
	while (day < 8)
	{
		printf("%5d", day);
		day++; 
	}
	printf("\n");
         break;
      case 2 :
    printf("%8d",day);
	day++; 
	while (day < 7)
	{
		printf("%5d", day);
		day++; 
	}
	printf("\n");
         break;
      case 3 :
    printf("%13d",day);
	day++; 
	while (day < 6)
	{
		printf("%5d", day);
		day++; 
	}
	printf("\n");
         break;
      case 4 :
    printf("%18d",day);
	day++; 
	while (day < 5)
	{
		printf("%5d", day);
		day++; 
	}
	printf("\n");
         break;
      case 5 :
    printf("%23d",day);
	day++; 
	while (day < 4)
	{
		printf("%5d", day);
		day++; 
	}
	printf("\n");
         break;
      case 6 :
    printf("%28d",day);
	day++; 
	while (day < 3)
	{
		printf("%5d", day);
		day++; 
	}
	printf("\n");
         break;
      case 7 :
    printf("%33d",day);
    printf("\n");
         break;
     }
     return 0; 
 }

int printDaysOfWeek(int currentDayNow)
{
	int daysPrinted = 0; 
	printf("%3d",currentDayNow);
	daysPrinted++;
	currentDayNow++; 
	while (daysPrinted < 7)
	{
		printf("%5d", currentDayNow);

		daysPrinted++;
		currentDayNow++;
	}
	printf("\n");
	return 0; 
}

int monthStart(int year, int month, int startDay)
{ 
  int numOfDays; 
  switch(month) {
      case 1 :
         //isFirstDay(numOfDays, startDay); 
         break;
      case 2 :
         numOfDays = 31; 
         return isFirstDay(numOfDays, startDay); 
      case 3 :
         if (isLeapYear(year) == 0)
         {
         numOfDays = 28; 
         return isFirstDay(numOfDays, startDay);
         }
         else
         {
          numOfDays = 29; 
         return isFirstDay(numOfDays, startDay);
         }
      case 4 :
         numOfDays = 31; 
         return isFirstDay(numOfDays, startDay);
         break;
      case 5 :
         numOfDays = 30; 
         return isFirstDay(numOfDays, startDay);
      case 6 :
         numOfDays = 31; 
         return isFirstDay(numOfDays, startDay);
      case 7 :
         numOfDays = 30; 
         return isFirstDay(numOfDays, startDay);
      case 8 :
         numOfDays = 31; 
         return isFirstDay(numOfDays, startDay);
      case 9 :
         numOfDays = 31; 
         return isFirstDay(numOfDays, startDay);
      case 10 :
         numOfDays = 30; 
         return isFirstDay(numOfDays, startDay);
      case 11 :
         numOfDays = 31; 
         return isFirstDay(numOfDays, startDay);
      case 12 :
         numOfDays = 30; 
         return isFirstDay(numOfDays, startDay);
     }
     return 0; 
}

int printSingleMonth(int numOfDays, int startDay)
{
   int day; 
   printWeek();
   printFirstWeek(startDay); 
   day = (9 - startDay);
   while(day < numOfDays)
     {
     	if ((numOfDays - day) >= 7)
     	{
     		printDaysOfWeek(day);
       		day = (day +7);
     	}
     	else
     	{
     		printf("%3d", day);
       		day++;
     		while ((numOfDays - day) > 0)
     		{
     		printf("%5d", day);
       		day++;
     		}
     	}
       		
     }
     printf("\n");
   return 0;
}

int printMonth(int year, int month, int startDay)
{ 
  //int dayOne; 
	switch(month) {
	  case 1 :
         printMonthName(1, year);
         printSingleMonth(32, startDay);
         break;
      case 2 :
      	 if (isLeapYear(year) == 0)
      	 {
      	 printMonthName(2, year);
         //dayOne = monthStart(year, month, startDay); 
         printSingleMonth(29, startDay);
      	 }
         else
         {
      	 printMonthName(2, year);
         //dayOne = monthStart(year, month, startDay); 
         printSingleMonth(30, startDay);
         }
         break;
      case 3 :
         printMonthName(3, year);
         //dayOne = monthStart(year, month, startDay); 
         printSingleMonth(32, startDay);
         break;
      case 4 :
         printMonthName(4, year);
         //dayOne = monthStart(year, month, startDay); 
         printSingleMonth(31, startDay);
         break;
      case 5 :
         printMonthName(5, year);
         //dayOne = monthStart(year, month, startDay); 
         printSingleMonth(32, startDay);
         break;
      case 6 :
         printMonthName(6, year);
         //dayOne = monthStart(year, month, startDay); 
         printSingleMonth(31, startDay);
         break;
      case 7 :
         printMonthName(7, year);
         //dayOne = monthStart(year, month, startDay);
         printSingleMonth(32, startDay);
         break;
      case 8 :
         printMonthName(8, year);
         //dayOne = monthStart(year, month, startDay); 
         printSingleMonth(32, startDay);
         break;
      case 9 :
         printMonthName(9, year);
         //dayOne = monthStart(year, month, startDay); 
         printSingleMonth(31, startDay);
         break;
      case 10 :
         printMonthName(10, year);
         //dayOne = monthStart(year, month, startDay); 
         printSingleMonth(32, startDay);
         break;
      case 11 :
         printMonthName(11, year);
         //dayOne = monthStart(year, month, startDay); 
         printSingleMonth(31, startDay);
         break;
      case 12 :
         printMonthName(12, year);
         //dayOne = monthStart(year, month, startDay); 
         printSingleMonth(32, startDay);
         break;
     }
     return 0; 
}



int printCalendar(int year, int startDay)
{ 
	int month = 1; 
  int firstDay = startDay; 
  //int newFirstDay = 0; 
  printMonth(year, month, firstDay);
  printf("\n");
  month++; 
	while (month < 13)
	{
    firstDay = monthStart(year, month, firstDay); 
		printMonth(year, month, firstDay); 
		month++; 
		printf("\n");
	}
    return 0; 
}
int main(int argc, char const *argv[])
{
// Inputted Year
	int inputYear; 

// Title
	printf("            MONTHLY CALENDAR           \n\n");
	printf("Please enter year for this calendar:- ");
	scanf("%d", &inputYear); 
  printf("\n\n   *** Calendar for %d ***   \n\n",inputYear);
  printCalendar(inputYear, startDayOfYear(inputYear));

	return 0;
}