# File Name: PA2_autograder.py
# Author: Jonathan Morse

# Used to access command line arguments 
import sys
sys.path.insert(0, '../')
from autograder_core import *
# Allows shell commands
import subprocess
# Allows access to file system
import os

def main(grader_first_name,grader_last_name,student_file_name):
    # Initializing values of earned points by students on tasks for project

    task_one_score_earned = 0
    task_two_score_earned = 0
    task_three_score_earned = 0
    task_four_score_earned = 0
    task_five_score_earned = 0
    task_six_score_earned = 0
    task_seven_score_earned = 0
    task_eight_score_earned = -1
    task_nine_score_earned = 0 
    task_ten_score_earned = -1

    # Initializing values of possible points that a student 
    # could earn on tasks for project

    task_one_score_possible = 4
    task_two_score_possible = 4
    task_three_score_possible = 4
    task_four_score_possible = 4
    task_five_score_possible = 4
    task_six_score_possible = 4
    task_seven_score_possible = 4
    task_eight_score_possible = 4 
    task_nine_score_possible = 4
    task_ten_score_possible = 4 

    # Initializing reason for score variables for tasks

    task_one_reason_for_score = ""
    task_two_reason_for_score = ""
    task_three_reason_for_score = ""
    task_four_reason_for_score = ""
    task_five_reason_for_score = ""
    task_six_reason_for_score = ""
    task_seven_reason_for_score = ""
    task_eight_reason_for_score = "Autograder cannot grade this task"
    task_nine_reason_for_score = ""
    task_ten_reason_for_score = "Autograder cannot grade this task"

    # Clean check
    clean_check(student_file_name)

    # Task 1. Make test
    task_one_test = make_all_files_test(task_one_score_possible, 
                                        student_file_name)

    task_one_score_earned = task_one_test[0]
    task_one_reason_for_score = task_one_test[1]

    # Task 2. Compile test
    Task_Two_Test = compile_test("cd %s; make" 
        % (student_file_name),
                                 task_two_score_possible)

    task_two_score_earned = Task_Two_Test[0]
    task_two_reason_for_score = Task_Two_Test[1]

    # Compile check
    compile_check_test = compile_check(task_two_score_earned, 
                                       task_two_score_possible, 
                                       student_file_name)

    # Ends autograder if program did not compile
    if task_one_score_earned != task_one_score_possible:
        return

    # Moves compiled program in PA2 directory
    subprocess.run("cp ./%s/life ./" 
        % (student_file_name),
                   shell=True,
                   stdout=subprocess.PIPE,
                   stderr=subprocess.PIPE)

    # Task 3. Initial configure and centering test
    
    task_three_test = array_compare("./life 4 4 0 " \
                                    + "task_three_test_input.txt y n;",
                                    "task_three_test_answer.txt",4)

    if task_three_test == 1:
    	task_three_score_earned = 4
    	task_three_reason_for_score = "Initial array is properly " \
                                      + "configured and centered"
    else:
    	task_three_score_earned = 0
    	task_three_reason_for_score = "Initial array is not " \
                                      + "properly configured and centered"
    
    # Task 4. Allocation at run time

    task_four_test = array_compare("./life 3 3 0 " \
                                       + "task_four_test_input.txt y n",
                                       "task_four_test_answer.txt",3)

    if task_four_test == 1 and task_three_test == 1:
        task_four_score_earned = 4 
        task_four_reason_for_score = "Array properly allocated at run time"
    else:
        task_four_score_earned = 0
        task_four_reason_for_score = "Array not properly allocated at run time"
    
    # Task 5. Use of 2 Dimensional Arrays
    if task_four_test == 1:
        task_five_score_earned = 4 
        task_five_reason_for_score = "Proper use of two-dimensional arrays"
    else:
        task_five_score_earned = 0
        task_five_reason_for_score = "Did not use two-dimensional arrays"

    # Task 6. Implementation of the game function

    # Outputs a list of strings that is the stdout of running the commands 

    # Tests for proper implementation of death
    Task_Six_Test_One = array_compare("./life 3 3 1 " \
                                      + "task_six_test_one_input.txt y n",
                                      "task_six_test_one_answer.txt",7) 
    # Tests for proper implementation of survival and birth
    Task_Six_Test_Two = array_compare("./life 4 4 1 " \
                                      "task_six_test_two_input.txt y n",
                                      "task_six_test_two_answer.txt",9) 

    if Task_Six_Test_One == 1:
        task_six_score_earned = 2
        task_six_reason_for_score = "\n\tThe test to ensure the death " \
                                    + "function was implementated correctly" \
                                    + " was successful"
    else:
        task_six_score_earned = 0
        task_six_reason_for_score = "\n\tThe test to ensure the death " \
                                    + "function was implementated correctly" \
                                    + " was unsuccessful"

    if Task_Six_Test_Two == 1:
        task_six_score_earned = task_six_score_earned + 2
        task_six_reason_for_score = task_six_reason_for_score \
                                    + "\n\tThe test to ensure the survival " \
                                    + "and birth functions were " \
                                    + "implementated correctly was successful"
    else:
        task_six_score_earned = task_six_score_earned
        task_six_reason_for_score = task_six_reason_for_score \
                                    + "\n\tThe test to ensure the" \
                                    + " survival and birth functions " \
                                    + "were implementated correctly " \
                                    + "was unsuccessful"

    # Task 7. Termination

    # Test for predetermined generations termination
    task_seven_test_one = termination_condition("./life 3 3 0 " \
                                                + "task_seven_test_" \
                                                + "one_input.txt y n",
                                                "task_seven_test_" \
                                                + "one_answer.txt",
                                                3,"predefined") 
    # Test for all cells are dead termination
    task_seven_test_two = termination_condition("./life 3 3 5 " \
                                                + "task_seven_test_" \
                                                + "two_input.txt y n",
                                                "task_seven_test_" \
                                                + "two_answer.txt",
                                                7,"dead") 
    # Test for steady state termination
    task_seven_test_three = termination_condition("./life 4 4 5 " \
                                                  + "task_seven_test_" \
                                                  + "three_input.txt y n",
                                                  "task_seven_test_" \
                                                  + "three_answer.txt",
                                                  14, "steady state")
    # Task for osilating state termination
    task_seven_test_four = termination_condition("./life 5 5 5 "
                                                 + "task_seven_test_" \
                                                 + "four_input.txt y n",
                                                 "task_seven_test_" \
                                                 + "four_answer.txt",
                                                 17, "oscilating") 

    if task_seven_test_one == 1:
        task_seven_score_earned = task_seven_score_earned + 1
        task_seven_reason_for_score = "\n\tThe test to ensure that game" \
                                      + " terminated when the predetermined" \
                                      + " number of generations was met, " \
                                      + "was implementated correctly was " \
                                      + "successful"
    else:
        task_seven_score_earned = task_seven_score_earned
        task_seven_reason_for_score = "\n\tThe test to ensure that game " \
                                      + "terminated when the predetermined" \
                                      + " number of generations was met, " \
                                      + "was implementated correctly was " \
                                      + "unsuccessful"

    if task_seven_test_two == 1:
        task_seven_score_earned = task_seven_score_earned + 1
        task_seven_reason_for_score = task_seven_reason_for_score \
                                      + "\n\tThe test to ensure that game " \
                                      + "terminated when all cells were " \
                                      + "dead, was implementated correctly" \
                                      + " was successful"
    else:
        task_seven_score_earned = task_seven_score_earned
        task_seven_reason_for_score = task_seven_reason_for_score \
                                      + "\n\tThe test to ensure that game " \
                                      + "terminated when all cells were " \
                                      + "dead, was implementated correctly" \
                                      + " was unsuccessful"

    if task_seven_test_three == 1:
        task_seven_score_earned = task_seven_score_earned + 1
        task_seven_reason_for_score = task_seven_reason_for_score \
                                      + "\n\tThe test to ensure that game " \
                                      + "terminated when in a steady state," \
                                      + " was implementated correctly " \
                                      + "was successful"
    else:
        task_seven_score_earned = task_seven_score_earned
        task_seven_reason_for_score = task_seven_reason_for_score \
                                      + "\n\tThe test to ensure that game " \
                                      + "terminated when in a steady state," \
                                      + " was implementated correctly was " \
                                      + "unsuccessful"

    if task_seven_test_four == 1:
        task_seven_score_earned = task_seven_score_earned + 1
        task_seven_reason_for_score = task_seven_reason_for_score \
                                      + "\n\tThe test to ensure that game " \
                                      + "terminated when oscilating, was " \
                                      + "implementated correctly was " \
                                      + "successful"
    else:
        task_seven_score_earned = task_seven_score_earned
        task_seven_reason_for_score = task_seven_reason_for_score \
                                      + "\n\tThe test to ensure that game " \
                                      + "terminated when oscilating, was " \
                                      + "implementated correctly was " \
                                      + "unsuccessful"

    # Task 9. Graders Test Cases

    if task_seven_test_four == 1:
        task_nine_score_earned = task_nine_score_possible
        task_nine_reason_for_score = "Test case was successful"

    # removes student folder
    subprocess.run("rm -r %s" % (student_file_name),
                   shell=True,
                   stdout=subprocess.PIPE,
                   stderr=subprocess.PIPE)
    # removes program file
    subprocess.run("rm life",
                   shell=True,
                   stdout=subprocess.PIPE,
                   stderr=subprocess.PIPE)

    # Opens the rubric text file
    r = open("../Output_Files/Rubrics/%s_PA2_rubric.txt" 
        % (student_file_name), "w")
    # Creates header
    r.write(str(header("TWO",
                       student_file_name,
                       grader_first_name,
                       grader_last_name,
                       "Forty(40)"
                       )))
    # Task 1
    r.write(str(task_create("One",
    	                   "Correct makefile to build program and" \
                           + " individual components and to clean up",
    	                   task_one_score_possible,
    	                   task_one_score_earned,
    	                   task_one_reason_for_score
    	                   )))
    # Task 2
    r.write(str(task_create("Two",
    	                   "Correct compilation without warnings " \
                           + "(using -Wall switch)",
    	                   task_two_score_possible,
    	                   task_two_score_earned,
    	                   task_two_reason_for_score
    	                   )))
    # Task 3
    r.write(str(task_create("Three",
    	                   "Correct reading the initial configuration" \
                           + " and centering it in the array",
    	                   task_three_score_possible,
    	                   task_three_score_earned,
    	                   task_three_reason_for_score
    	                   )))
    # Task 4
    r.write(str(task_create("Four",
    	                   "Correct allocation of arrays at run time",
    	                   task_four_score_possible,
    	                   task_four_score_earned,
    	                   task_four_reason_for_score
    	                   )))
    # Task 5 
    r.write(str(task_create("Five",
    	                   "Correct use of two-dimensional arrays",
    	                   task_five_score_possible,
    	                   task_five_score_earned,
    	                   task_five_reason_for_score)))
    # Task 6
    r.write(str(task_create("Six",
    	                   "Correct implementation of game function",
    	                   task_six_score_possible,
    	                   task_six_score_earned,
    	                   task_six_reason_for_score
    	                   )))
    # Task 7 
    r.write(str(task_create("Seven",
    	                   "Correct test for termination",
    	                   task_seven_score_possible,
    	                   task_seven_score_earned,
    	                   task_seven_reason_for_score
    	                   )))
    # Task 8
    r.write(str(task_create("Eight",
    	                   "Satisfactory test cases",
    	                   task_eight_score_possible,
    	                   task_eight_score_earned,
    	                   task_eight_reason_for_score
    	                   )))
    # Task 9
    r.write(str(task_create("Nine",
    	                   "Correct execution with graders` test cases",
    	                   task_nine_score_possible,
    	                   task_nine_score_earned,
    	                   task_nine_reason_for_score
    	                   )))
    # Task 10
    r.write(str(task_create("Ten",
    	                   "Satisfactory README file, including " \
                           + "loop invariants", 
    	                   task_ten_score_possible,
    	                   task_ten_score_earned,
    	                   task_ten_reason_for_score
    	                   )))
    return;

main(sys.argv[1],sys.argv[2],sys.argv[3])
