# File Name: PA3_autograder.py
# Author: Jonathan Morse


# Used to access command line arguments 
import sys
sys.path.insert(0, '../')
from autograder_core import *
# Allows shell commands
import subprocess
# Allows access to file system
import os

def main(grader_first_name,grader_last_name,student_file_name):

    # Initializing values of earned points by students on tasks for project

    task_one_score_earned = 0
    task_two_score_earned = 0
    task_three_score_earned = 0
    task_four_score_earned = 0 
    task_five_score_earned = 0 
    task_six_score_earned = -1
    task_seven_score_earned = 0
    task_eight_score_earned = -1
    task_nine_score_earned = -1

    # Initializing values of possible points that a student could earn on tasks for project

    task_one_score_possible = 5
    task_two_score_possible = 5
    task_three_score_possible = 5
    task_four_score_possible = 5
    task_five_score_possible = 5
    task_six_score_possible = 5
    task_seven_score_possible = 5
    task_eight_score_possible = 5
    task_nine_score_possible = 10

    # Initializing reason for score variables for tasks

    task_one_reason_for_score = ""
    task_two_reason_for_score = ""
    task_three_reason_for_score = ""
    task_four_reason_for_score = ""
    task_five_reason_for_score = ""
    task_six_reason_for_score = "Autograder cannot grade this task"
    task_seven_reason_for_score = ""
    task_eight_reason_for_score = "Autograder cannot grade this task"
    task_nine_reason_for_score = "Autograder cannot grade this task"

    # Clean check
    clean_check(student_file_name)

    # Task One. Compile Test

    task_one_test = compile_test("cd %s; make" 
        % (student_file_name),
                                 task_one_score_possible)
    task_one_score_earned = task_one_test[0]
    task_one_reason_for_score = task_one_test[1]

    # Compile check
    compile_check_test = compile_check(task_two_score_earned, 
                                       task_two_score_possible, 
                                       student_file_name)
    # Ends autograder if program did not compile
    if task_one_score_earned != task_one_score_possible:
        return

    # Task Two. Number of files
    task_two_test = counting_modules(task_two_score_possible,student_file_name)
    task_two_score_earned = task_two_test[0]
    task_two_reason_for_score = task_two_test[1]

    # Moves the compiled program file into the PA3 directory
    subprocess.run("cp ./%s/PA3 ./" 
        % (student_file_name),
                   shell=True,
                   stdout=subprocess.PIPE,
                   stderr=subprocess.PIPE)

    # Task Three. Correct creation of binary trees
    
    task_three_test = total_word_scan("./PA3 test_three_output.txt " \
                                      + "program_test_input_one.txt " \
                                      + "program_test_input_two.txt",
                                      "test_three_output.txt",
                                      "total_word_test_answer.txt",
                                      task_three_score_possible,
                                      "Test for correct creation of " \
                                      + "binary trees")
    task_three_score_earned = task_three_test[0]
    task_three_reason_for_score = task_three_test[1]

    # Removes test_three_output.txt because it is no longer needed
    subprocess.run("rm test_three_output.txt",
                   shell=True,
                   stdout=subprocess.PIPE,
                   stderr=subprocess.PIPE)

    # Task Four. Correct traversal of binary trees

    task_four_test = individual_word_scan("./PA3 task_four_output.txt " \
                                          + "program_test_input_one " \
                                          + "program_test_input_two",
                                          "task_four_output.txt",
                                          "individual_word_test_answer.txt",
                                          task_four_score_possible,
                                          "\n\tTest for correct traversal of " \
                                          + "binary trees")
    task_four_score_earned = task_four_test[0]
    task_four_reason_for_score = task_four_test[1]

    # Removes test_four_output.txt because it is no longer needed
    subprocess.run("rm task_four_output.txt",
                   shell=True,
                   stdout=subprocess.PIPE,
                   stderr=subprocess.PIPE)

    # Task Five. Correct malloc() use

    if task_four_test[0] == task_four_score_possible:
        task_five_score_earned = task_five_score_possible
        task_five_reason_for_score = "\n\tNo segmentation fault when running" \
                                     + "program, malloc() was used properly"
    else:
        task_five_score_earned = 0
        task_five_reason_for_score = "\n\tSegmentation fault occured when " \
                                     + "running program, malloc() was not " \
                                     + "used properly"


    # Task Seven. Test Cases
    if task_three_test[0] == task_three_score_possible \
        and task_four_test[0] == task_four_score_possible:

        task_seven_score_earned = task_seven_score_possible
        task_seven_reason_for_score = "Test case was successful"

    # Removes compiled program file and student folder
    subprocess.run("rm PA3; rm -r %s;" 
        % (student_file_name),
                   shell=True,
                   stdout=subprocess.PIPE,
                   stderr=subprocess.PIPE)    

    # Opens the rubric text file
    r = open("../Output_Files/Rubrics/%s_PA3_rubric.txt"
        % (student_file_name), "w")
    # Creates header
    r.write(str(header("THREE",
    	               student_file_name,
                       grader_first_name,
                       grader_last_name,
    	               "Forty(40) or Fifty(50) with extra credit"
    	               )))
    # Task 1
    r.write(str(task_create("One",
    	                   "Correctly build from the makefile without " \
                           + "warnings (with –Wall switch)",
    	                   task_one_score_possible,
    	                   task_one_score_earned,
    	                   task_one_reason_for_score
    	                   )))
    # Task 2
    r.write(str(task_create("Two",
    	                   "Organization of program into at least " \
                           + "three modules",
    	                   task_two_score_possible,
    	                   task_two_score_earned,
    	                   task_two_reason_for_score
    	                   )))
    # Task 3
    r.write(str(task_create("Three",
    	                   "Correct construction of binary tree and " \
                           "insertion of nodes",
    	                   task_three_score_possible,
    	                   task_three_score_earned,
    	                   task_three_reason_for_score
    	                   )))
    # Task 4
    r.write(str(task_create("Four",
    	                   "Correct traversal of binary tree and output of " \
                           + "information according to specified",
    	                   task_four_score_possible,
    	                   task_four_score_earned,
    	                   task_four_reason_for_score
    	                   )))
    # Task 5 
    r.write(str(task_create("Five",
    	                   "Correct use of malloc() and correctly freeing " \
                           + "all malloc’ed data",
    	                   task_five_score_possible,
    	                   task_five_score_earned,
    	                   task_five_reason_for_score
    	                   )))
    # Task 6
    r.write(str(task_create("Six",
    	                   "Proper destruction of tree and all of its " \
                           + "objects before exiting",
    	                   task_six_score_possible,
    	                   task_six_score_earned,
    	                   task_six_reason_for_score
    	                   )))
    # Task 7 
    r.write(str(task_create("Seven",
    	                   "Correct execution with graders’ test cases",
    	                   task_seven_score_possible,
    	                   task_seven_score_earned,
    	                   task_seven_reason_for_score
    	                   )))
    # Task 8
    r.write(str(task_create("Eight",
    	                   "Satisfactory README file, including output of " \
                           + "two non-trivial test cases",
    	                   task_eight_score_possible,
    	                   task_eight_score_earned,
    	                   task_eight_reason_for_score
    	                   )))
    # Task 9
    r.write(str(task_create("Nine (Extra Credit)",
    	                   "Make your binary tree into an AVL tree",
    	                   task_nine_score_possible,
    	                   task_nine_score_earned,
    	                   task_nine_reason_for_score
    	                   )))
    return;

main(sys.argv[1],sys.argv[2],sys.argv[3])